// zǍDI(PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;

	// ȃf[^̈ʒu
	struct fpos md[] =
	{
		{ 0x0f, 0x05, 0x0700 }, // BGM
		{ 0x0f, 0x0c, 0x0500 }, // BGM
		{ 0x10, 0x01, 0x0300 }, // BGM
		{ 0x10, 0x04, 0x0700 }, // BGM
		{ 0x10, 0x0b, 0x0200 }, // ACLb`
		{ 0x10, 0x0d, 0x0800 }, // Ăї
		{ 0x10, 0x0e, 0x0100 }, // mbN
		{ 0x10, 0x0f, 0x0100 }, // A[
//		{ 0x10, 0x10, 0x0100 }, // Ȃ
		{ 0x11, 0x01, 0x0100 }, // ʉ
		{ 0x11, 0x02, 0x0100 }, // wZ̃`C
//		{ 0x11, 0x03, 0x0100 }, // Ȃ
		{ 0x11, 0x04, 0x0100 }, // db
		{ 0x11, 0x05, 0x1300 }, // BGM
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	disk.SelectDisk(0);
	disk.SetRecordRange(0x01,0x10);
//	fcut("INTWRP", 0x12, 0x09, 0x00, 0x0c, 0x01, 0x0000, 0x0100);
	fcut("DRIVER", 0x11, 0x08, 0x01, 0x0e, 0x01, 0x0000, 0x0d00);
	fcut("VOICE",  0x0f, 0x07, 0x01, 0x02, 0x01, 0x0000, 0x0300);
	// ȃf[^؂o
	for (i=0; md[i].sec; i++)
	{
		sprintf(fname,"MUS%02d",i);
		fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
	}
	return 0;
}

